//
//  commandTransmission.c
//  UAV Imaging
//
//  Created by Shen Yue on 12-03-29.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#include <stdio.h>
#include <unistd.h>
#include "commandTransmission.h"
#include "ftpTransmission.h"
#include "configuration.h"
#include <string.h>

char commandName[NUMBER_OF_CONNANDS][COMMAND_LINE_LENGTH]={"SHUTTER_SPEED","TEST"};

CURL *downloadCurlhandle=NULL;

void initCommandTransmission(void)
{
    downloadCurlhandle=initHandle();
}

void cleanupCommandTransmission(void)
{
    cleanupHandle(downloadCurlhandle);
}

void commandTransmissionControl(COMMAND command,COMMAND* newCommand)
{
    char path[FILE_PATH_LENGTH];
    sprintf(path, "%s/%s",LOCALPATH_COMMAND,COMMAND_FILENAME);
    char url[URL_LENGTH];
    sprintf(url, "%s/%s",GROUND_STATION_URL_COMMAND,COMMAND_FILENAME);
    do
    {
        sleep(COMMAND_LOADING_FREQUENCY);
        while (transmitCommand(url, path)!=1)
        {
            sleep(COMMAND_LOADING_FREQUENCY);
        }
    }
    while(loadCommand(path,command,newCommand)==0);
}

int transmitCommand(char *url,char *path)
{
    return download(downloadCurlhandle, url, path, CONNECTION_TIMEOUT);
}
int loadCommand(char* path,COMMAND command,COMMAND* newCommand)
{
    int changed=0;
    char name[COMMAND_LINE_LENGTH];
    int value;
    char line[COMMAND_LINE_LENGTH];
    int i;
    FILE * fp;
    fp=fopen(path, "r");
    if (fp!=NULL)
    {
        while (fgets(line,COMMAND_LINE_LENGTH,fp)!=NULL)
        {
            if(sscanf(line, "%s %d",name,&value)==2)
            {
                for (i=0; i<NUMBER_OF_CONNANDS; i++) 
                {
                    if (strcmp(name, commandName[i])==0)
                    {
                        if (newCommand->value[i]!=value)
                        {
                            newCommand->value[i]=value;
                            changed=1;
                        }
                        break;
                    }
                }
            }
        }
    }
    return changed;
}