/*
 The following funtions are modified from http://blog.csdn.net/vipfengxiao/article/details/6027742
 int upload(CURL *curlhandle, const char * remotepath, const char * localpath, long timeout);
 size_t getcontentlengthfunc(void *ptr, size_t size, size_t nmemb, void *stream);
 size_t discardfunc(void *ptr, size_t size, size_t nmemb, void *stream);
 size_t readfunc(void *ptr, size_t size, size_t nmemb, void *stream);
 */

#include "ftpTransmission.h"
#include <stdio.h>
#include "imageTransmission.h"
#include "configuration.h"
#include <unistd.h>

CURL *uploadCurlhandle=NULL;

void waitForNextAttempt(void);

void initImageTransmission(void)
{
    uploadCurlhandle=initHandle();
}

void cleanupImageTransmission(void)
{
    cleanupHandle(uploadCurlhandle);
}

void transmitControl(int imageNumber)
{
    char path[FILE_PATH_LENGTH];
    sprintf(path, "%s/%d.%s",FILE_PATH_PROCESSED,imageNumber,PROCESSED_IMAGE_FORMAT);
    char url[URL_LENGTH];
    sprintf(url, "%s/%d.%s",GROUND_STATION_URL_IMAGE,imageNumber,PROCESSED_IMAGE_FORMAT);
    
    while (upload(uploadCurlhandle, url, path, CONNECTION_TIMEOUT)!=1)
    {
        waitForNextAttempt();
    }
    
    sprintf(path, "%s/%d.%s",FILE_PATH_INFO,imageNumber,INFO_FORMAT);
    sprintf(url, "%s/%d.%s",GROUND_STATION_URL_INFO,imageNumber,INFO_FORMAT);
    
    while (upload(uploadCurlhandle, url, path, CONNECTION_TIMEOUT)!=1)
    {
        waitForNextAttempt();
    }
}

void waitForNextAttempt(void)
{
    usleep((useconds_t)(DELAY_BEFORE_REATTEMPT*1000000));
}
