//
//  utility.h
//  UAV Imaging
//
//  Created by Shen Yue on 12-02-27.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#ifndef UAV_Imaging_utility_h
#define UAV_Imaging_utility_h

//******************** ArrayIntQueue ********************
//simple array int queue, does not have error checking
typedef struct arrayIntQueue {
    int *array;
    int head;
    int tail;
    int size;
    int count;
} ARRAY_INT_QUEUE;
ARRAY_INT_QUEUE* mallocArrayIntQueue(int size);
void freeArrayIntQueue(ARRAY_INT_QUEUE* queue);
void addToArrayIntQueueHead(ARRAY_INT_QUEUE* queue,int number);
int removeFromArrayIntQueueHead(ARRAY_INT_QUEUE* queue);
void addToArrayIntQueueTail(ARRAY_INT_QUEUE* queue,int number);
int removeFromArrayIntQueueTail(ARRAY_INT_QUEUE* queue);
//*******************************************************

//******************** twoDIntPointerArray ********************
typedef struct twoDIntPointerArray{
    int *** data;
    int width;
    int height;
}TWO_D_INT_POINTER_ARRAY;

TWO_D_INT_POINTER_ARRAY* mallocTwoDIntPointerArray(int width,int height);
void freeTwoDIntPointerArray(TWO_D_INT_POINTER_ARRAY* array);
//*************************************************************

//******************** intPointerQueue ********************
typedef struct intPointerSinglyLinkedListNode {
    int *value;
    struct intPointerSinglyLinkedListNode *nextNode;
} INT_POINTER_SINGLY_LINKED_LIST_NODE;

typedef struct intPointerQueue
{
    INT_POINTER_SINGLY_LINKED_LIST_NODE *firstNode;
    INT_POINTER_SINGLY_LINKED_LIST_NODE *lastNode;
} INT_POINTER_QUEUE;

INT_POINTER_QUEUE *mallocIntPointerQueue(void);
void addToIntPointerQueue(INT_POINTER_QUEUE *queue,int *value);
int removeFromIntPointerQueue(INT_POINTER_QUEUE *queue,int **value);
void emptyIntPointerQueue(INT_POINTER_QUEUE *queue);
void freeIntPointerQueue(INT_POINTER_QUEUE *queue);
//**********************************************************

//******************** ArrayTwoIntQueue ********************
typedef struct arrayTwoIntQueue {
    int *arrayX;
    int *arrayY;
    int head;
    int tail;
    int size;
    int count;
} ARRAY_TWO_INT_QUEUE;
ARRAY_TWO_INT_QUEUE* mallocArrayTwoIntQueue(int size);
void freeArrayTwoIntQueue(ARRAY_TWO_INT_QUEUE* queue);
void addToArrayTwoIntQueue(ARRAY_TWO_INT_QUEUE* queue,int x,int y);
int removeFromArrayTwoIntQueue(ARRAY_TWO_INT_QUEUE* queue,int *x, int *y);
//*******************************************************

// ************************* Timer *************************
long int timer(long int start);
//***********************************************************

//************************* withinRange *************************
int withinRangeInt(int value,int min,int max);
int withinRangeFloat(float value,float min,float max);
//***************************************************************
 
#endif
