--------------------------------------------------------------------------------
-- Description: Verify the functionality of the search box
-- 
-- VHDL Test Bench Created by ISE for module: search_box
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY search_box_tb IS
END search_box_tb;
 
ARCHITECTURE behavior OF search_box_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT search_box
    PORT(
         Clock : IN  std_logic;
	 Reset : IN  std_logic;
         a : IN  std_logic_vector(7 downto 0);
         b : IN  std_logic_vector(7 downto 0);
         c : IN  std_logic_vector(7 downto 0);
         d : IN  std_logic_vector(7 downto 0);
         e : IN  std_logic_vector(7 downto 0);
         f : IN  std_logic_vector(7 downto 0);
         g : IN  std_logic_vector(7 downto 0);
         h : IN  std_logic_vector(7 downto 0);
         i : IN  std_logic_vector(7 downto 0);
         j : IN  std_logic_vector(7 downto 0);
         k : IN  std_logic_vector(7 downto 0);
         l : IN  std_logic_vector(7 downto 0);
         m : IN  std_logic_vector(7 downto 0);
         n : IN  std_logic_vector(7 downto 0);
         o : IN  std_logic_vector(7 downto 0);
         p : IN  std_logic_vector(7 downto 0);
	 
         Marker : OUT  std_logic_vector(7 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal Clock : std_logic := '0';
   signal Reset : std_logic := '0';
   signal a : std_logic_vector(7 downto 0) := (others => '0');
   signal b : std_logic_vector(7 downto 0) := (others => '0');
   signal c : std_logic_vector(7 downto 0) := (others => '0');
   signal d : std_logic_vector(7 downto 0) := (others => '0');
   signal e : std_logic_vector(7 downto 0) := (others => '0');
   signal f : std_logic_vector(7 downto 0) := (others => '0');
   signal g : std_logic_vector(7 downto 0) := (others => '0');
   signal h : std_logic_vector(7 downto 0) := (others => '0');
   signal i : std_logic_vector(7 downto 0) := (others => '0');
   signal j : std_logic_vector(7 downto 0) := (others => '0');
   signal k : std_logic_vector(7 downto 0) := (others => '0');
   signal l : std_logic_vector(7 downto 0) := (others => '0');
   signal m : std_logic_vector(7 downto 0) := (others => '0');
   signal n : std_logic_vector(7 downto 0) := (others => '0');
   signal o : std_logic_vector(7 downto 0) := (others => '0');
   signal p : std_logic_vector(7 downto 0) := (others => '0');

 	--Outputs
   signal Marker : std_logic_vector(7 downto 0) := (others => '0');

   -- Clock period definitions
   constant Clock_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: search_box PORT MAP (
          Clock => Clock,
          Reset => Reset,
          Marker => Marker,
          a => a,
          b => b,
          c => c,
          d => d,
          e => e,
          f => f,
          g => g,
          h => h,
          i => i,
          j => j,
          k => k,
          l => l,
          m => m,
          n => n,
          o => o,
          p => p
        );

   -- Clock process definitions
   Clock_process :process
   begin
		Clock <= '0';
		wait for Clock_period/2;
		Clock <= '1';
		wait for Clock_period/2;
		Clock <= '0';
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      --wait for 100 ns;	
      wait for Clock_period;

      -- insert stimulus here 
		Reset <= '0';
		a <= x"01";
		b <= x"02";
		c <= x"01";
		d <= x"01";
		e <= x"03";
		f <= x"04";
		g <= x"01";
		h <= x"02";
		i <= x"03";
		j <= x"03";
		k <= x"01";
		l <= x"02";
		m <= x"03";
		n <= x"01";
		o <= x"01";
		p <= x"04";
		wait for Clock_period;

		--Reset <= '1';
		a <= x"01";
		b <= x"01";
		c <= x"01";
		d <= x"01";
		e <= x"01";
		f <= x"03";
		g <= x"01";
		h <= x"02";
		i <= x"01";
		j <= x"01";
		k <= x"01";
		l <= x"01";
		m <= x"01";
		n <= x"01";
		o <= x"01";
		p <= x"01";
		wait for Clock_period;

		--wait;
   end process;

END;
