-- Test to verify the functionality of search box top level

library IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

entity search_box_top_tb is

end search_box_top_tb;

architecture tstb_top of search_box_top_tb is

component search_box_top
port(
	padClk, padReset : in std_logic;
	padA, padB, padC, padD, padE, padF, padG, padH, padI, padJ, padK, padL, padM, padN, padO, padP : in std_logic_vector(7 downto 0);
	padMarker : out std_logic_vector(7 downto 0)
	);
end component;

signal clk : std_logic := '0';
signal reset : std_logic := '0';
signal asig, bsig, csig, dsig, esig, fsig, gsig, hsig, isig, jsig, ksig, lsig, msig, nsig, osig, psig : std_logic_vector(7 downto 0);
signal markersig : std_logic_vector(7 downto 0);

begin

sb_top : search_box_top
port map(	padClk => clk,
		padReset => reset,
		padA => asig,
		padB => bsig,
		padC => csig,
		padD => dsig,
		padE => asig,
		padF => bsig,
		padG => csig,
		padH => dsig,
		padI => asig,
		padJ => bsig,
		padK => csig,
		padL => dsig,
		padM => asig,
		padN => bsig,
		padO => csig,
		padP => dsig,
		padMarker => markersig);

clk_generator : process
begin
	clk <= '1' after 50 ns, '0' after 100 ns;
	wait until clk = '0';
end process clk_generator;

input_test_routine : process
variable pipeline_delay : integer := 4; -- change this variable depending on the number of pipelines stages
begin

	-- test 1 2 1 1 3 4 1 2 3 3 1 2 3 1 1 4
	asig <= "00000001"; bsig <= "00000010"; csig <= "00000001"; dsig <= "00000001";
	esig <= "00000011"; fsig <= "00000100"; gsig <= "00000001"; hsig <= "00000010";
	isig <= "00000011"; jsig <= "00000011"; ksig <= "00000001"; lsig <= "00000010";
	msig <= "01100011"; nsig <= "00000001"; osig <= "00000001"; psig <= "00000100";
	for i in 1 to pipeline_delay loop
		wait until falling_edge( clk );
	end loop;
	assert markersig = "00000000"
		report "test 0 failed"
		severity warning;

	-- test 1 1 1 1 1 3 1 2 1 1 1 1 1 1 1 1
	asig <= "00000001"; bsig <= "00000001"; csig <= "00000001"; dsig <= "00000001";
	esig <= "00000001"; fsig <= "00000011"; gsig <= "00000001"; hsig <= "00000010";
	isig <= "00000001"; jsig <= "00000001"; ksig <= "00000001"; lsig <= "00000001";
	msig <= "00000001"; nsig <= "00000001"; osig <= "00000001"; psig <= "00000001";
	for i in 1 to pipeline_delay loop
		wait until falling_edge( clk );
	end loop;
	assert markersig = "11111111"
		report "test 1 failed"
		severity warning;

end process input_test_routine;

end tstb_top;
